#!/bin/bash
# ##################################################
# Activate Swap file for Neptune
# by Leszek Lesner
# released under the terms of GPLv3
# ##################################################
if [ "$(id -u)" != "0" ]; then
   echo "This script must be run as root" 1>&2
   exit 1
fi
if [ "$1" == "-d" ]; then
	echo ""
        if [ "$#" -gt 1 ]; then
		FILE_SW=$2
		echo -n "Deactivating Swapfile..."
		swapoff $FILE_SW;
        	echo "done"
		echo -n "Deleting /etc/fstab line for autostarting swapfile..."
        	cat /etc/fstab | grep -Ev $FILE_SW > /tmp/fstab;
        	mv /tmp/fstab /etc/fstab;
        	echo "done"
	fi
elif ([ "$1" == "-h" ] || [ "$1" == "--help" ]); then
	echo -n $0
	echo "     activate swapfile"
	echo -n "$0 -d	deactivate swapfile"
        echo " "
else
	clear ;
	echo "============== Activate Swap file for Neptune =============="
	echo -n "Please enter the size of the Swapfile you want to use (in MB): "
	read SIZE_MB ;
	echo " "
	echo "Please enter the target path where you want to create your Swapfile "
	echo -n "(e.g. /media/20F2-0BE9/swapfile.img): "
	read FILE_SW ;
	echo " "
	echo -n "Creating Swapfile..."
	dd if=/dev/zero of=$FILE_SW bs=1M count=$SIZE_MB >/dev/null 2>&1 
	echo "done"
	echo -n "Formatting Swapfile..."
	mkswap $FILE_SW > /tmp/mkswap.log 2>/dev/null;
	echo "done"
	cat /tmp/mkswap.log
	echo -n "Activating Swap..."
	swapon $FILE_SW ;
	echo "done"
	echo -n "Writing /etc/fstab to autostart Swapfile..."
	echo "${FILE_SW}       none            swap    sw      0       0" >> /etc/fstab ;
	echo "done"
fi
