#!/bin/bash
# #############################################
# List all installed packages sorted by size
# by Leszek Lesner
# released under the terms of GPLv3
# ############################################
if [ "$1" = "--help" ] || [ "$1" = "-h" ] || [ "$1" = "-?" ]; then
  echo "$0 [-kb]"
  echo ""
  echo "-kb	Show KiloBytes instead of MegaBytes"
  echo ""
  exit 0
fi
clear
echo "========= Packages installed (list by size) =========" 
echo "          (Press q to exit list)" 
sleep 3
#dpkg-query -W --showformat='${Installed-Size} ${Package}\n' | sort -nr | less # Old
# Newer and better version showing filesize in human readable values
if [ "$1" = "-kb" ]; then
  dpkg-query --show --showformat='${Package;-50}\t${Installed-Size}\n' | sort -k 2 -n -r | grep -v deinstall | awk '{printf "%.0f KB \t %s\n", $2, $1}' | less
else  
  dpkg-query --show --showformat='${Package;-50}\t${Installed-Size}\n' | sort -k 2 -n -r | grep -v deinstall | awk '{printf "%.3f MB \t %s\n", $2/(1024), $1}' | less
fi
